var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.register = void 0;
const protocol_1 = require("../../protocol");
const language_core_1 = require("@volar/language-core");
function register(connection, projects, env) {
    connection.onNotification(protocol_1.ReportStats.type, () => __awaiter(this, void 0, void 0, function* () {
        var _a, _b, _c, _d, _e, _f, _g, _h, _j, _k, _l, _m, _o;
        for (const [rootUri, _workspace] of projects.workspaces) {
            connection.console.log('workspace: ' + rootUri);
            const workspace = yield _workspace;
            connection.console.log('documentRegistry stats: ' + ((_a = workspace.documentRegistry) === null || _a === void 0 ? void 0 : _a.reportStats()));
            connection.console.log('');
            connection.console.log('tsconfig: inferred');
            const _inferredProject = workspace.getInferredProjectDontCreate();
            if (_inferredProject) {
                connection.console.log('loaded: true');
                const inferredProject = yield _inferredProject;
                connection.console.log('largest 10 files:');
                for (const script of [...inferredProject.scripts.values()]
                    .sort((a, b) => { var _a, _b, _c, _d; return ((_b = (_a = b.snapshot) === null || _a === void 0 ? void 0 : _a.getLength()) !== null && _b !== void 0 ? _b : 0) - ((_d = (_c = a.snapshot) === null || _c === void 0 ? void 0 : _c.getLength()) !== null && _d !== void 0 ? _d : 0); })
                    .slice(0, 10)) {
                    connection.console.log('  - ' + script.fileName);
                    connection.console.log(`    size: ${(_b = script.snapshot) === null || _b === void 0 ? void 0 : _b.getLength()}`);
                }
                connection.console.log('files:');
                for (const script of inferredProject.scripts.values()) {
                    connection.console.log('  - ' + script.fileName);
                    connection.console.log(`    size: ${(_c = script.snapshot) === null || _c === void 0 ? void 0 : _c.getLength()}`);
                    connection.console.log(`    ref counts: "${(_e = (_d = workspace.documentRegistry).getLanguageServiceRefCounts) === null || _e === void 0 ? void 0 : _e.call(_d, script.fileName, (_g = (_f = inferredProject.languageServiceHost).getScriptKind) === null || _g === void 0 ? void 0 : _g.call(_f, script.fileName))})"`);
                }
            }
            else {
                connection.console.log('loaded: false');
            }
            connection.console.log('');
            for (const _project of workspace.projects.values()) {
                const project = yield _project;
                connection.console.log('tsconfig: ' + project.tsConfig);
                connection.console.log('loaded: ' + !!project.getLanguageServiceDontCreate());
                connection.console.log('largest 10 files:');
                for (const script of [...project.scripts.values()]
                    .sort((a, b) => { var _a, _b, _c, _d; return ((_b = (_a = b.snapshot) === null || _a === void 0 ? void 0 : _a.getLength()) !== null && _b !== void 0 ? _b : 0) - ((_d = (_c = a.snapshot) === null || _c === void 0 ? void 0 : _c.getLength()) !== null && _d !== void 0 ? _d : 0); })
                    .slice(0, 10)) {
                    connection.console.log('  - ' + script.fileName);
                    connection.console.log(`    size: ${(_h = script.snapshot) === null || _h === void 0 ? void 0 : _h.getLength()}`);
                }
                connection.console.log('files:');
                for (const script of project.scripts.values()) {
                    connection.console.log('  - ' + script.fileName);
                    connection.console.log(`    size: ${(_j = script.snapshot) === null || _j === void 0 ? void 0 : _j.getLength()}`);
                    connection.console.log(`    ref counts: "${(_l = (_k = workspace.documentRegistry).getLanguageServiceRefCounts) === null || _l === void 0 ? void 0 : _l.call(_k, script.fileName, (_o = (_m = project.languageServiceHost).getScriptKind) === null || _o === void 0 ? void 0 : _o.call(_m, script.fileName))})"`);
                }
            }
            connection.console.log('');
        }
    }));
    connection.onRequest(protocol_1.GetMatchTsConfigRequest.type, (params) => __awaiter(this, void 0, void 0, function* () {
        const project = (yield projects.getProject(params.uri));
        if (project === null || project === void 0 ? void 0 : project.tsconfig) {
            return { uri: env.fileNameToUri(project.tsconfig) };
        }
    }));
    connection.onRequest(protocol_1.GetVirtualFileNamesRequest.type, (document) => __awaiter(this, void 0, void 0, function* () {
        var _p, _q, _r;
        const project = yield projects.getProject(document.uri);
        const fileNames = [];
        if (project) {
            const rootVirtualFile = (_q = (_p = project.project) === null || _p === void 0 ? void 0 : _p.getLanguageService().context.core.virtualFiles.getSource(env.uriToFileName(document.uri))) === null || _q === void 0 ? void 0 : _q.root;
            if (rootVirtualFile) {
                const kinds = (_r = document.fileKinds) !== null && _r !== void 0 ? _r : [language_core_1.FileKind.TypeScriptHostFile];
                (0, language_core_1.forEachEmbeddedFile)(rootVirtualFile, e => {
                    if (e.snapshot.getLength() && kinds.includes(e.kind)) {
                        fileNames.push(e.fileName);
                    }
                });
            }
        }
        return fileNames;
    }));
    connection.onRequest(protocol_1.GetVirtualFileRequest.type, (params) => __awaiter(this, void 0, void 0, function* () {
        var _s, _t, _u, _v;
        const project = yield projects.getProject(params.sourceFileUri);
        if (project) {
            const [virtualFile, source] = (_t = (_s = project.project) === null || _s === void 0 ? void 0 : _s.getLanguageService().context.core.virtualFiles.getVirtualFile(params.virtualFileName)) !== null && _t !== void 0 ? _t : [];
            if (virtualFile && source) {
                const mappings = {};
                for (const mapping of virtualFile.mappings) {
                    const sourceUri = env.fileNameToUri((_u = mapping.source) !== null && _u !== void 0 ? _u : source.fileName);
                    (_v = mappings[sourceUri]) !== null && _v !== void 0 ? _v : (mappings[sourceUri] = []);
                    mappings[sourceUri].push(mapping);
                }
                return {
                    content: virtualFile.snapshot.getText(0, virtualFile.snapshot.getLength()),
                    mappings,
                };
            }
        }
    }));
    connection.onNotification(protocol_1.ReloadProjectNotification.type, () => {
        projects.reloadProject();
    });
    connection.onNotification(protocol_1.WriteVirtualFilesNotification.type, (params) => __awaiter(this, void 0, void 0, function* () {
        var _w;
        const fs = yield Promise.resolve().then(() => require('fs'));
        const project = yield projects.getProject(params.uri);
        if (project) {
            const ls = (_w = (yield project.project)) === null || _w === void 0 ? void 0 : _w.getLanguageServiceDontCreate();
            if (ls) {
                const sourceFiles = new Set(ls.context.host.getScriptFileNames());
                for (const virtualFile of ls.context.core.typescript.languageServiceHost.getScriptFileNames()) {
                    if (virtualFile.startsWith(ls.context.host.getCurrentDirectory()) && !sourceFiles.has(virtualFile)) {
                        const snapshot = ls.context.core.typescript.languageServiceHost.getScriptSnapshot(virtualFile);
                        if (snapshot) {
                            fs.writeFile(virtualFile, snapshot.getText(0, snapshot.getLength()), () => { });
                        }
                    }
                }
            }
        }
    }));
}
exports.register = register;
//# sourceMappingURL=customFeatures.js.map